/*
 * Copyright 2009-2011 Collaborative Research Centre SFB 632 
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package annis.dao;

import java.util.List;

import annis.model.Annotation;
import java.util.LinkedList;

public class AnnotatedSpan {

	private long id;
	private String coveredText;
	private List<Annotation> annotations;
  private List<Annotation> metadata;

  public AnnotatedSpan(long id, String coveredText,
    List<Annotation> annotations)
  {
    this(id, coveredText, annotations, new LinkedList<Annotation>());
  }
  
	public AnnotatedSpan(long id, String coveredText, 
    List<Annotation> annotations, List<Annotation> metadata) 
  {
		super();
		this.id = id;
		this.coveredText = coveredText;
		this.annotations = annotations;
    this.metadata = metadata;
	}

	public long getId() {
		return id;
	}
	
	public void setId(long id) {
		this.id = id;
	}
	
	public String getCoveredText() {
		return coveredText;
	}
	
	public void setCoveredText(String coveredText) {
		this.coveredText = coveredText;
	}
	
	public List<Annotation> getAnnotations() {
		return annotations;
	}
	
	public void setAnnotations(List<Annotation> annotations) {
		this.annotations = annotations;
	}

  public List<Annotation> getMetadata()
  {
    return metadata;
  }

  public void setMetadata(List<Annotation> metadata)
  {
    this.metadata = metadata;
  }
	
  
}
